/**
 * CBOS - Coffe Bean Ordering System
 * ICS52 - Software Engineering - University of California - Irvine
 * Fall 2000
 * 
 * @author Arvind Krishna
 * @author Roberto Silveira Silva Filho 
 * @version 1.0
 *
 */

import java.io.*;
import java.util.Date;

public class PrintLog {

	public String logFileName;

	public static void main(String args[]) 	{

		if (args.length >0) {
			PrintLog obj = new PrintLog();
			
			for (int t=0; t<args.length;t++) {
				obj.logFileName=args[t];
				obj.printLog();
			}
		} else {
			System.out.println("Wrong argument number!");
			System.out.println("PrintLog usage:");
			System.out.println("java PrintLog filenames list");
		}
	}

	protected void printLog() {
		RandomAccessFile inputLog=null;
		Date date = null;
		String character = null;		
		File file = new File(logFileName);
		
		if (file.exists()) {

			try {
				inputLog = new RandomAccessFile(file,"r");

			} catch ( IOException ex ) {

				System.out.println("PringLog: Error while opening file: "+logFileName);
				System.out.println(ex);
			}
			
			try {

				try {

					while (true) {

						character = (new Character(inputLog.readChar())).toString();

						//System.out.println(date+" "+message);
						System.out.println(character);
					}


				} catch (EOFException ex) {

					System.out.println();
					System.out.println("------------------------------- END OF LOG FILE -------------------------------");
					//System.out.println(ex);
				}
			} catch (IOException ex) {
				System.out.println("Error while reading log file!");
				System.out.println(ex);
			}

		} else {
			System.out.println();
			System.out.println("File not found!");
			System.out.println();

		}

	}

}