/**
 * CBOS - Coffe Bean Ordering System
 * ICS52 - Software Engineering - University of California - Irvine
 * Fall 2000
 * 
 * @author Arvind Krishna
 * @author Roberto Silveira Silva Filho 
 * @version 1.0
 *
 */

package cbos.adt;

import java.util.Date;

public class InventoryADT implements java.io.Serializable	
{
	private String kind;
	private QualityADT quality;
	private Date date;
	private int bags;
	private double price;
	
	public InventoryADT ( String newKind, QualityADT newQuality, Date newDate, int newBags, double newPrice) {
		kind	= newKind; 
		quality = newQuality;
		date	= newDate;
		bags	= newBags;
		price   = newPrice;
	}
	
	public boolean equals (InventoryADT inventory) {
		
		if ( (this.getKind()).equals(inventory.getKind()) &&
			 (this.getQuality()).equals(inventory.getKind()) &&
			 (this.getDate()).equals(inventory.getDate()) &&
			 (this.getBags() == inventory.getBags()) &&
			 (this.getPrice() == inventory.getPrice())
			) { 
			return true;
		} else {		
			return false;
		}
	}
	
	public int getBags() {
		return bags;
	}
	
	public void setBags(int value) {
		bags = value;
	}
	
	public String getKind() {
		return kind;
	}
	
	public void setKind(String value) {
		kind = value;
	}
	
	public QualityADT getQuality() {
		return (QualityADT)quality.clone();
	}
	
	public void setQuality(QualityADT value) {
		quality = (QualityADT) value.clone();
	}
	
	public Date getDate() {
		return date;
	}
	
	public void setDate( Date value) {
		date = value;
	}
	
	public double getPrice() {
		return price;
	}
	
	public void setPrice( double value) {
		price = value;
	}
}
