/**
 * CBOS - Coffe Bean Ordering System
 * ICS52 - Software Engineering - University of California - Irvine
 * Fall 2000
 * 
 * @author Arvind Krishna
 * @author Roberto Silveira Silva Filho 
 * @version 1.0
 *
 */

package cbos.adt;

public final class QualityADT implements java.lang.Cloneable, java.io.Serializable	 {
	
	private int ___value;
	
	public static final int _exceptional = 0;
	public static final QualityADT exceptional = new QualityADT(_exceptional);
	
	public static final int _very_high = 1;
	public static final QualityADT very_high = new QualityADT(_very_high);
	
	public static final int _high = 2;
	public static final QualityADT high = new QualityADT(_high);
	
	public static final int _average = 3;
	public static final QualityADT average = new QualityADT(_average);
	
	public static final int _low = 4;
	public static final QualityADT low = new QualityADT(_low);

	public static final QualityADT IT_ENUM_MAX = new QualityADT(Integer.MAX_VALUE);

	public int value () {
		return ___value;
	}

	public static QualityADT from_int (int value) {
		switch (value) {
		case _exceptional : return exceptional;

		case _very_high : return very_high;

		case _high : return high;
					 
		case _average : return average;
						
		case _low : return low;

		default : 
					return IT_ENUM_MAX;
		}
	}
	
	/**
	 * @returns the string value of the current quality
	 */
	public String toString () {
		switch (___value) {
		case _exceptional : return "exceptional";

		case _very_high : return "very_high";

		case _high : return "high";
					 
		case _average : return "average";
						
		case _low : return "low";

		default : 
					return null;
		}
	}

	public static QualityADT from_String (String value) {
		
		if (value.equals("exceptional")) return exceptional;

		if (value.equals("very_high")) return very_high;

		if (value.equals("high")) return high;
		
		if (value.equals("average")) return average;
		
		if (value.equals("low")) return low;

		return IT_ENUM_MAX;
		
	}
	
	private QualityADT (int value) {
		___value = value;
	}

	/**
	 * Compares this ADT with another one
	 * @return true if equal, false if not
	 */
	public boolean equals (QualityADT other) {
		if (other.value() == this.value()) {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * Compares this ADT with another one
	 * @return true if >=, false if not
	 */
	public boolean greaterOrEquals (QualityADT other) {
		if (other.value() >= this.value()) {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * Compares this ADT with another one
	 * @return true if <, false if not
	 */
	public boolean lessThan (QualityADT other) {
		if (other.value() < this.value()) {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * Creates a new object duplicate
	 */
	public java.lang.Object clone()
	{
		return from_int(___value);
	}
}
