/**
 * CBOS - Coffe Bean Ordering System
 * ICS52 - Software Engineering - University of California - Irvine
 * Fall 2000
 * 
 * @author Arvind Krishna
 * @author Roberto Silveira Silva Filho 
 * @version 1.0
 *
 */

package cbos.adt;

public final class UserFunctionADT implements java.lang.Cloneable, java.io.Serializable	 {
	
	private int ___value;
	
	public static final int _manager = 0;
	public static final UserFunctionADT manager = new UserFunctionADT(_manager);
	
	public static final int _buy_attendant = 1;
	public static final UserFunctionADT buy_attendant = new UserFunctionADT(_buy_attendant);
	
	public static final int _sale_attendant = 2;
	public static final UserFunctionADT sale_attendant = new UserFunctionADT(_sale_attendant);
	
	public static final int _warehouse = 3;
	public static final UserFunctionADT warehouse = new UserFunctionADT(_warehouse);

	public static final UserFunctionADT IT_ENUM_MAX = new UserFunctionADT(Integer.MAX_VALUE);

	public int value () {
		return ___value;
	}

	public static UserFunctionADT from_int (int value) {
		switch (value) {
		case _manager : return manager;

		case _sale_attendant : return sale_attendant;

		case _buy_attendant : return buy_attendant;
					 
		case _warehouse : return warehouse;
						

		default : 
					return IT_ENUM_MAX;
		}
	}

	/**
	 * Returns a string with the current corresponding function
	 */
	public String toString () {
		switch (___value) {
		case _manager : return "manager";

		case _sale_attendant : return "sale_attendant";

		case _buy_attendant : return "buy_attendant";
					 
		case _warehouse : return "warehouse";
						

		default : 
					return null;
		}
	}
	
	public static UserFunctionADT from_String (String value) {
		
		if (value.equals("manager")) return manager;

		if (value.equals("sale_attendant")) return sale_attendant;

		if (value.equals("buy_attendant")) return buy_attendant;
		
		if (value.equals("warehouse")) return warehouse;
		
		return IT_ENUM_MAX;
		
	}
	
	private UserFunctionADT (int value) {
		___value = value;
	}

	/**
	 * Compares this ADT with another one
	 * @return true if equal, false if not
	 */
	public boolean equals (UserFunctionADT other) {
		if (other.value() == this.value()) {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * Compares this ADT with another one
	 * @return true if >=, false if not
	 */
	public boolean greaterOrEquals (UserFunctionADT other) {
		if (other.value() >= this.value()) {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * Compares this ADT with another one
	 * @return true if <, false if not
	 */
	public boolean lessThan (UserFunctionADT value) {
		if (value.value() < this.value()) {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * Creates a new object duplicate
	 */
	public java.lang.Object clone()
	{
		return from_int(___value);
	}
}
