
/**
 * CBOS - Coffe Bean Ordering System
 * ICS52 - Software Engineering - University of California - Irvine
 * Fall 2000
 * 
 * @author Arvind Krishna
 * @author Roberto Silveira Silva Filho 
 * @version 1.0
 *
 */

package cbos.client;

import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JTable;
import javax.swing.JScrollPane;
import javax.swing.table.TableColumn;
import javax.swing.DefaultCellEditor;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;

import java.awt.*;
import java.awt.event.*;

import cbos.adt.*;
import cbos.server.*;

import java.util.*;
import javax.swing.*;

public class IntroductionClient extends cbos.client.Client {
	
	private boolean print = false;
	
	private JTextArea introText;
	private JButton introTextButton;
	private JButton bugsReportButton;
	
	private String introduction = " ";
	
	/**
	 * Constructor
	 */
	public IntroductionClient(ServerFactoryInterface value) {
		super(value);
		init();	
		
	}
	
	private void init() {
		introduction =  " INTRODUCTION TO THE STUDENTS \n\n";
		introduction += " You have to find at least 14 errors (bugs) spread all over the system \n";
		introduction += " Each time you find an error, the system stores this information in the \n";
		introduction += " bugtracker.cbos file stored in the ./Databases directory. At first time,\n";
		introduction += " this file will be created. \n\n";
		introduction += " All database files will be created, after the first execution, in the \n";
		introduction += " ./Databases/ directory. \n\n\n";
		introduction += " Good luck!! \n";
		
		
		formatForm();
		handleEvents();
	}
	
	private void formatForm() {
		
		if (print) 
			System.out.println("Formating sale Client...");
		
		this.setLayout(new FlowLayout(FlowLayout.LEFT));
		Border betched = BorderFactory.createEtchedBorder();
		
		add(new JLabel("Instructions for students about id and etc."));
		
		//JPanel introTextPanel = new JPanel(new FlowLayout(FlowLayout.CENTER),false);
		introText = new JTextArea();
		introText.setWrapStyleWord(true);
		JScrollPane reportScrollPane = new JScrollPane(introText);
		reportScrollPane.setPreferredSize(new Dimension(600, 450));
		reportScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		introText.setEnabled(false);
		this.add(reportScrollPane);
		
		introTextButton = new JButton("Introduction");
		bugsReportButton = new JButton("Bugs Report");
		
		this.add(introTextButton);
		this.add(bugsReportButton);
		
		
	} //END OF FORMAT FORM
	
		
	
	/**
	 * Handles the events generated by the interface buttons
	 */
	private void handleEvents() {
		
		// Copy the introduction to the text area
		introTextButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				introText.removeAll();
				introText.setText(introduction);
			}
			}
										);
		
		bugsReportButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Log log = serverFactory.getLog();
				boolean[] bugs = log.listBugsArray();
				String studentId = log.getId();
				String providedId = serverFactory.getLogin();
				String message = " ";
			
				message += "Student ID in the bugstrack.cbos file: "+studentId+"\n";
				message += "Student ID provided in the login     : "+providedId+"\n\n";
				
				if (! studentId.equals(providedId)) {
					message += "WARNING, PROVIDED ID DIFFERENT FROM ID IN THE bugstrack.cbos FILE,\n";
					message += "YOUR BUGS WILL NOT BE REPORTED. \n";
					message += "PROVIDE THE CORRECT ID OR ERASE THE bugstrack.cbos FILE AND START AGAIN \n";
					message += "NOTE: IF YOU ERASE THE bugstrack.cbos FILE, A NEW (RESETED) ONE WILL BE CREATED. \n\n";
				}
				
				message += "BUG NUMBER \t\t FOUND?\n\n";
				for (int t=0; t<bugs.length; t++) {
					message += "Bug "+t+": \t\t"+bugs[t]+"\n";
				}
				introText.removeAll();
				introText.setText(message);
			}
			
			}
										);
		
		
	} //END OF HANDLE EVENTS
	
	
	
} //end of the class definition
