/**
 * CBOS - Coffe Bean Ordering System
 * ICS52 - Software Engineering - University of California - Irvine
 * Fall 2000
 * 
 * @author Arvind Krishna
 * @author Roberto Silveira Silva Filho 
 * @version 1.0
 *
 */

package cbos.client;

import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JTable;
import javax.swing.JScrollPane;
import javax.swing.table.TableColumn;
import javax.swing.DefaultCellEditor;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;

import java.awt.*;
import java.awt.event.*;

import cbos.adt.*;
import cbos.server.*;

import java.util.*;
import javax.swing.*;

public class InventoryClient extends cbos.client.Client implements InventoryClientInterface {
	
	private CBOSTableModel tabModel;  // Model of the table: headers and data
	private JTable orderTable;        // Table widget   	
	private JTextField dateField;
	private JButton futureDateButton;
	
	private boolean print = true;
	
	/**
	 * Constructor
	 */
	public InventoryClient(ServerFactoryInterface value) {
		super(value);
		init();	
		
	}
	
	private void init() {
		formatForm();
		handleEvents();
	}
	
	
	private void formatForm() {
		
		if (print) 
			System.out.println("InventoryClient: Formating...");
	
		this.setLayout(new FlowLayout(FlowLayout.LEFT));
		Border betched = BorderFactory.createEtchedBorder();
				
		// Purchase Table
		
		Vector columnNames = new Vector(0,1);
		columnNames.addElement("Kind");
		columnNames.addElement("Quality");
		columnNames.addElement("#Bags");
		columnNames.addElement("Date");
		columnNames.addElement("Price");
		
		InventoryInterface inventory = serverFactory.getInventory();
		Vector inventoryList = inventory.availabilityList();
		Vector data = new Vector(0,1);
		InventoryADT inventoryElement;
		
		for (int t=0; t<inventoryList.size(); t++) {
			inventoryElement = (InventoryADT) inventoryList.elementAt(t);
			data.addElement(inventoryElement.getKind());
			data.addElement(inventoryElement.getQuality());
			data.addElement(new Integer(inventoryElement.getBags()));
			
			Date tempDate = inventoryElement.getDate();
			Calendar tableDate = Calendar.getInstance();
			tableDate.setTime(tempDate);
			String dateString = (new Integer(tableDate.get(Calendar.MONTH)).toString());
			dateString +="/"+tableDate.get(Calendar.DAY_OF_MONTH);
			dateString +="/"+tableDate.get(Calendar.YEAR);
		
			data.addElement(dateString);
			data.addElement(new Double(inventoryElement.getPrice()));
		}
			
		JPanel orderPanel = new JPanel(new FlowLayout(FlowLayout.LEFT),false);
		tabModel = new CBOSTableModel(columnNames, data);
		orderTable = new JTable(tabModel);
		orderTable.setPreferredScrollableViewportSize(new Dimension(420, 310));
		JScrollPane orderScrollPane = new JScrollPane(orderTable);
		orderTable.setEnabled(false);
		orderScrollPane.setEnabled(true);
		
		
		this.add( new JLabel("Order information:"));
		orderPanel.add(orderScrollPane);
		this.add(orderPanel);
		
		this.add(new JLabel("Date:"));
		dateField = new JTextField(8);
		this.add(dateField);
		
		futureDateButton = new JButton("FutureDate");
		this.add(futureDateButton);
		
		// Creates a new line in the table
		futureDateButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			
				Log log = serverFactory.getLog();
				log.submitBug(serverFactory.getLogin(),8);
			
			}
			}
										);
		
	}
	
	private void handleEvents() {
	
	}
}
