package cbos.client;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.table.*;
import cbos.server.*;
import cbos.adt.*;
import java.util.*;
   

public class PurchaseWarehouseClient extends cbos.client.Client implements WarehouseClientInterface {
	
	private String[] quality = {"exceptional", "very_high", "high", "average","low"};
	private String[] kind = {}; // Must be copied from the kind class
	
	JPanel panel = new JPanel();
	JButton submitButton = new JButton("Submit");
	JButton addLineButton = new JButton("AddLine");
	JButton removeLineButton = new JButton("RemoveLine");
	private JLabel label1 = new JLabel("PurchaseWarehouse");
	private InventoryInterface invInterface;
	private NormalPurchaseOrderInterface npi;
	private String list = "Sentinel\t";
	private JTable orderTable = null;
	private CBOSTableModel model = null;
	private boolean print = false;
	private Log log = null;
	
	private JComboBox POComboBox = null;
	private JComboBox kindComboBox = null;
	private JComboBox qualityComboBox = null;
		
	public PurchaseWarehouseClient(InventoryInterface inv,NormalPurchaseOrderInterface normalInterface, ServerFactoryInterface value)
	{
		super(value);
		invInterface = serverFactory.getInventory();
		npi = serverFactory.getNormalPurchaseOrder();
		showTable();
	}
	
	
	public void showTable()
	{
		
		this.setLayout(new FlowLayout(FlowLayout.LEFT));
		this.add(label1);
		
		// Initialize Purchase Table
		
		Vector columnNames = new Vector(0,1);
		columnNames.addElement("Order#");
		columnNames.addElement("Kind");
		columnNames.addElement("Quality");
		columnNames.addElement("#Bags");
		
		Vector data = new Vector(0,1);
		data.addElement("");
		data.addElement("");
		data.addElement("");
		data.addElement(new Integer(0));
		
		model = new CBOSTableModel(columnNames, data);
		orderTable = new JTable(model);  // is the table
		
		
		orderTable.setPreferredScrollableViewportSize(new Dimension(600, 420));
		JScrollPane orderScrollPane = new JScrollPane(orderTable);
		orderScrollPane.setEnabled(true);
		TableColumn POcolumn = orderTable.getColumnModel().getColumn(0);
		TableColumn kindColumn = orderTable.getColumnModel().getColumn(1);
		TableColumn qualityColumn = orderTable.getColumnModel().getColumn(2);
		JComboBox qualityComboBox = new JComboBox(quality);
		POComboBox = new JComboBox(getPO()); // returns a list of PO's
		qualityColumn.setCellEditor(new DefaultCellEditor(qualityComboBox));
		POcolumn.setCellEditor(new DefaultCellEditor(POComboBox));
		kindComboBox = new JComboBox();
		updateKindComboBox();
		kindColumn.setCellEditor(new DefaultCellEditor(kindComboBox));
		panel.add(orderScrollPane);
		
		this.add(panel);
		
		//this.add(panel, BorderLayout.CENTER);
		
		submitButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{ 	updateInventory();
			}
			}
								  );
		this.add(submitButton);
		//this.add(submitButton, BorderLayout.SOUTH);
		addLineButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
			model.addNewLine();
			TableColumn qualityColumn = orderTable.getColumnModel().getColumn(2);
			JComboBox qualityComboBox = new JComboBox(quality);
			qualityColumn.setCellEditor(new DefaultCellEditor(qualityComboBox));
			TableColumn kindColumn = orderTable.getColumnModel().getColumn(1);
			updateKindComboBox();
			kindColumn.setCellEditor(new DefaultCellEditor(kindComboBox));
			TableColumn POColumn = orderTable.getColumnModel().getColumn(0);
			POComboBox = new JComboBox(getPO());
			POColumn.setCellEditor(new DefaultCellEditor(POComboBox)); 
			
			
			}
			}
								  );
		this.add(addLineButton);

		removeLineButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				model.removeLine(orderTable.getSelectedRow());
			}
}

);
this.add(removeLineButton); 
	
}// end of the function defenition
	

	public void updateInventory()
	{
		for( int i=0; i < model.getRowCount(); i++)
			for( int j =0; j < model.getColumnCount(); j++)
				list += model.getValueAt(i,j) + "\t";
		
		generateOrder(); // updates the inventory
		model.setNull();// sets all the elements in the table to null
	}

	public void generateOrder()
	{
		if (print)
			System.out.println("generate order:" + list);
		StringTokenizer tokens = new StringTokenizer(list);
		QualityADT qualityADT = null; 
		Date date = new Date();
		tokens.nextToken(); // removes the sentinel form the string
		while( tokens.hasMoreTokens())
		{
			try{
			
				String POnumber = (String) tokens.nextToken();
				String kind = (String)tokens.nextToken();
				String quality = (String) tokens.nextToken();
				int bags = Integer.parseInt((String)tokens.nextToken());
				if(bags < 0)
				{
					log = serverFactory.getLog();
					String studentId = serverFactory.getLogin();
					log.submitBug(studentId, 10);
				}
				if (print)
					System.out.println(" Po number :" + POnumber + "Kind " + kind + "quality" + quality + "bags " + bags);
				
				ShipmentReceiveADT shipment = new ShipmentReceiveADT();
				shipment.setBags(bags);
				shipment.setDate(date);
				shipment.setKind(kind);
				shipment.setQuality(qualityADT.from_String(quality));
				if(print)
					System.out.println(" PurchaseWareHouseClient:generateOrder()Before updating Po");
				boolean success = npi.updatePurchaseOrder(shipment, POnumber); // adds it on to the norma purchase order */
				if(success)
				{
					if (print)
					System.out.println("Updated the normal order Successfully");
					invInterface.addInventory(POnumber, bags, kind, qualityADT.from_String(quality), date);
				}
					
				}catch(Exception e)
				{
				JOptionPane.showMessageDialog(null, "Error: PurchaseWareHouseClient:Error in the input Data--  " + e, "Error Message", JOptionPane.ERROR_MESSAGE);
					System.out.println(e);
				}
		}
		list = "Sentinel\t"; // reassignes the sentinel value
	}
	
	/**
	 * Updates the kindComboBox when a new kind is updated in the system
	 */
	public void updateKindComboBox() {
		KindInterface kind = serverFactory.getKind();
		Vector kindsList = kind.getAllKinds();
		
		if (print)	
			System.out.println("PurchaseClient: adding "+kindsList.size()+" kinds");
		
		if (kindsList == null) {
			kindComboBox.removeAllItems();
			kindComboBox.addItem("NONE");
		
		} else {
			kindComboBox.removeAllItems();
			for (int t=0; t<kindsList.size(); t++) {
				kindComboBox.addItem(kindsList.elementAt(t));
			}
		}
	}
	
	/** 
	 * Updates the purchase order combo box when a new order is input in the syestem
	 */
	public void updateOrderComboBox() {
		Vector poList = getPO();
		
		if (print) {
			System.out.println("PurchaseWarehouseClient: updating order combo box...");
			System.out.println("PurchaseWarehouseClient: adding "+poList.size()+" kinds");
		}
		
		if (poList == null) {
			POComboBox.removeAllItems();
			POComboBox.addItem("NONE");
			
		} else {
			POComboBox.removeAllItems();
			for (int t=0; t<poList.size(); t++) {
				POComboBox.addItem(poList.elementAt(t));
			}
		}
	}
	
	/**
	 * Queries the purchase ordesr list for a list of orders.
	 */
	public Vector getPO()
	{
		Vector list = new Vector();
		
		Enumeration elements = npi.getOrderNumbers();
		if(elements.hasMoreElements())
		{
			while(elements.hasMoreElements())
			{
				list.addElement((String) elements.nextElement());
			}
		}
		else
		{
			list.add(" ");
		}
		return list;
	}
			
	
	
}// end of the class 