package cbos.client;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.table.*;
import cbos.server.*;
import cbos.adt.*;
import java.util.*;
   

public class SalesWarehouseClient extends cbos.client.Client implements WarehouseClientInterface {
	
	private String[] quality = {"exceptional", "very_high", "high", "average","low"};
	private String[] kind = {}; // Must be copied from the kind class
	
	JPanel panel = new JPanel();
	JButton submitButton = new JButton("Submit");
	JButton addLineButton = new JButton("AddLine");
	JButton removeLineButton = new JButton("RemoveLine");
	private InventoryInterface invInterface;
	private NormalSalesOrderInterface nsi; // Normal sales order
	private String list = "Sentinel\t";
	private JTable orderTable = null;
	private CBOSTableModel model = null;
	private boolean print = false;
	
	private JComboBox kindComboBox;
	private JComboBox SOComboBox;
	
	public SalesWarehouseClient(InventoryInterface inv,NormalPurchaseOrderInterface normalInterface, ServerFactoryInterface value)
	{
		super(value);
		invInterface = serverFactory.getInventory();
		nsi = serverFactory.getNormalSalesOrder();
		showTable();
	}
	
	
	public void showTable()
	{
		
		this.setLayout(new FlowLayout(FlowLayout.LEFT));
		this.add(new JLabel("PurchaseWarehouse"));
		
		// Initialize Purchase Table
		
		Vector columnNames = new Vector(0,1);
		columnNames.addElement("Order#");
		columnNames.addElement("Kind");
		columnNames.addElement("Quality");
		columnNames.addElement("#Bags");
		
		Vector data = new Vector(0,1);
		data.addElement(new String(""));
		data.addElement(new String(""));
		data.addElement(new String(""));
		data.addElement(new Integer(0));
		
		model = new CBOSTableModel(columnNames, data);
		orderTable = new JTable(model);  // is the table
		
		
		orderTable.setPreferredScrollableViewportSize(new Dimension(600, 420));
		JScrollPane orderScrollPane = new JScrollPane(orderTable);
		orderScrollPane.setEnabled(true);
		TableColumn salesColumn = orderTable.getColumnModel().getColumn(0);
		TableColumn kindColumn = orderTable.getColumnModel().getColumn(1);
		TableColumn qualityColumn = orderTable.getColumnModel().getColumn(2);
		
		JComboBox qualityComboBox = new JComboBox(quality);
		qualityColumn.setCellEditor(new DefaultCellEditor(qualityComboBox));
		
		SOComboBox = new JComboBox(getSO()); // returns a list of PO's
		salesColumn.setCellEditor(new DefaultCellEditor(SOComboBox));
		
		// Copy the kind vector to the combo box
		kindComboBox = new JComboBox(kind);
		kindColumn.setCellEditor(new DefaultCellEditor(kindComboBox));
		
		// Fills up the kinds list
		KindInterface kind = serverFactory.getKind();
		Vector kindList = kind.getAllKinds();
		for (int t=0; t<kindList.size(); t++) {
			kindComboBox.addItem(kindList.elementAt(t));
		}
		
		panel.add(orderScrollPane);
		
		this.add(panel);
		
		//this.add(panel, BorderLayout.CENTER);
		
		submitButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{ 	updateInventory();
			}
			}
								  );
		this.add(submitButton);
		//this.add(submitButton, BorderLayout.SOUTH);
		addLineButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
			model.addNewLine();
			TableColumn qualityColumn = orderTable.getColumnModel().getColumn(2);
			JComboBox qualityComboBox = new JComboBox(quality);
			qualityColumn.setCellEditor(new DefaultCellEditor(qualityComboBox));
			
			}
			}
								  );
		this.add(addLineButton);

		removeLineButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				model.removeLine(orderTable.getSelectedRow());
			}
}

);
this.add(removeLineButton); 
	
}// end of the function defenition
	

	public void updateInventory()
	{
		for( int i=0; i < model.getRowCount(); i++)
			for( int j =0; j < model.getColumnCount(); j++)
				list += (String)model.getValueAt(i,j) + "\t";
		model.setNull();// sets all the elements in the table to null
		generateOrder(); // updates the inventory
	}

	private void generateOrder()
	{
		/*StringTokenizer tokens = new StringTokenizer(list);
		QualityADT qualityADT = null; 
		Date date = new Date();
		System.out.println("number of tokens = "+ tokens.countTokens());
		tokens.nextToken(); // removes the sentinel form the string
		while( tokens.hasMoreTokens())
		{
			
			String POnumber = tokens.nextToken();
			String kind = tokens.nextToken();
			String quality = tokens.nextToken();
			int bags = Integer.parseInt(tokens.nextToken());
			try
			{
				invInterface.removeInventory(POnumber, bags, kind, qualityADT.from_String(quality), date);
			}
			catch(Exception e)
			{
				System.out.println(e);
			}
			ShipmentReceiveADT shipment = new ShipmentReceiveADT();
			shipment.setBags(bags);
			shipment.setDate(date);
			shipment.setKind(kind);
			shipment.setQuality(qualityADT.from_String(quality));
			nsi.updatePurchaseOrder(shipment, POnumber); // adds it on to the norma purchase order 
		}
		list = "Sentinel\t"; // reassignes the sentinel value */
		
	    
		if (print)
			System.out.println("generate order:" + list);
		StringTokenizer tokens = new StringTokenizer(list);
		QualityADT qualityADT = null; 
		Date date = new Date();
		tokens.nextToken(); // removes the sentinel form the string
		while( tokens.hasMoreTokens())
		{
			try{
			
				String POnumber = (String) tokens.nextToken();
				String kind = (String)tokens.nextToken();
				String quality = (String) tokens.nextToken();
				int bags = Integer.parseInt((String)tokens.nextToken());
				if (print)
					System.out.println(" Po number :" + POnumber + "Kind " + kind + "quality" + quality + "bags " + bags);
				
				ShipmentReceiveADT shipment = new ShipmentReceiveADT();
				shipment.setBags(bags);
				shipment.setDate(date);
				shipment.setKind(kind);
				shipment.setQuality(qualityADT.from_String(quality));
				if(print)
					System.out.println(" PurchaseWareHouseClient:generateOrder()Before updating Po");
				boolean success = nsi.updateSalesOrder(shipment, POnumber); // adds it on to the norma purchase order */
				if(success)
				{
					if (print)
					System.out.println("Updated the normal order Successfully");
					invInterface.removeInventory(POnumber, bags, kind, qualityADT.from_String(quality), date);
				}
					
				}catch(Exception e)
				{
				JOptionPane.showMessageDialog(null, "Error: SalesWareHouseClient: Inpuy Data Exception--  " + e, "Error Message", JOptionPane.ERROR_MESSAGE);
					System.out.println(e);
				}
		}
		list = "Sentinel\t"; // reassignes the sentinel value
	}//end of the function
	
	
	
	public void updateKindComboBox() {
		KindInterface kind = serverFactory.getKind();
		Vector kindsList = kind.getAllKinds();
		
		if (print)	
			System.out.println("PurchaseClient: adding "+kindsList.size()+" kinds");
		
		if (kindsList == null) {
			kindComboBox.removeAllItems();
			kindComboBox.addItem("NONE");
		
		} else {
			kindComboBox.removeAllItems();
			for (int t=0; t<kindsList.size(); t++) {
				kindComboBox.addItem(kindsList.elementAt(t));
			}
		}
	}
	
	
	/** 
	 * Updates the purchase order combo box when a new order is input in the syestem
	 */
	public void updateOrderComboBox() {
		Vector soList = getSO();
		
		if (print) {
			System.out.println("PurchaseWarehouseClient: updating order combo box...");
			System.out.println("SalesWarehouseClient: adding "+soList.size()+" kinds");
		}
		
		if (soList == null) {
			SOComboBox.removeAllItems();
			SOComboBox.addItem("NONE");
			
		} else {
			SOComboBox.removeAllItems();
			for (int t=0; t<soList.size(); t++) {
				SOComboBox.addItem(soList.elementAt(t));
			}
		}
	}
	
	
	
	/**
	 * Get a list of slale order numbers
	 */
	public Vector getSO()
	{
		Vector list = new Vector();
		
		Enumeration elements = nsi.getOrderNumbers();
		if(elements.hasMoreElements())
		{
			while(elements.hasMoreElements())
			{
				list.addElement((String) elements.nextElement());
			}
		}
		else
		{
			list.add(" ");
		}
		return list;
	}
	
	
}// end of the class 