/**
 * CBOS - Coffe Bean Ordering System
 * ICS52 - Software Engineering - University of California - Irvine
 * Fall 2000
 * 
 * @author Arvind Krishna
 * @author Roberto Silveira Silva Filho 
 * @version 1.0
 *
 */
package cbos.client.reports;

import javax.swing.*;
import cbos.adt.*;
import java.util.*;
import java.awt.*;
import cbos.server.NormalPurchaseOrderInterface;

public class DailyActualPickup implements DailyActualPickupInterface
{
	private NormalPurchaseOrderInterface npi;
	private Hashtable scheduled_kindTable; //stores the various kinds of coffee
	private Hashtable receive_kindTable;
	private JPanel panel;
	

	private boolean print = false;
	
	// the references of the normal orders and that of the growers is passed to invoke the functions
	public DailyActualPickup(NormalPurchaseOrderInterface npo)
	{
		npi = npo; //assigns the reference
		
	}// end of the constructor call
	
	public String getOutput()
	{
		Enumeration elements;
		
		ShipmentOrderADT shipment;
		ShipmentReceiveADT shipment_receive;
		JTextArea outputArea = new JTextArea();
		Vector actualList, scheduledList;
		scheduled_kindTable = new Hashtable(10, (float) 0.8); // stores the list per kind
		receive_kindTable = new Hashtable(10, (float) 0.8); // stores the list per kind
		int scheduled_qualityamount[], receive_qualityamount[]; 
		scheduled_qualityamount = new int[5]; // list based on the quality in the scheduled list
		receive_qualityamount = new int[5]; // list based on the quality in the actual list
		Date date = new Date();
		AddressADT address;
		KindDetailsADT kinds = new KindDetailsADT();			
		
		String output = " ";  // contains the output of the report!!
		
		if(print)
			System.out.println("inside actual pickup:the normal purchaseOrderRefernce is "+npi);
		
		scheduledList = npi.getScheduledPickUp(date);
		actualList = npi.getActualPickUp(date);
		
		if(print)
			System.out.println("Inside Actual Pickup:After getting the actual list");
		if( ! scheduledList.isEmpty())
		{
			elements = scheduledList.elements();
			output += "THE SCHEDULED LIST OF ORDERS\n";
			if(print)
				System.out.println("Inside Actual Pickup:inside scheduled list");
			while( elements.hasMoreElements())
			{								
				output += "BAGS\tKIND\tQUALITY\n";
				shipment = (ShipmentOrderADT) elements.nextElement();
				output += shipment.getBags() + "\t";
				int bags = shipment.getBags();
				output += shipment.getKind() + "\t";
				String kind = shipment.getKind();
				
				kinds.setKind(kind);
				kinds.setQuantity(bags);
				
				if(scheduled_kindTable.isEmpty()) {	
					scheduled_kindTable.put(kind, kinds);
				} else	{//mens that there are some entries in the table
					if(scheduled_kindTable.contains(kinds)) {
						KindDetailsADT temp = (KindDetailsADT) scheduled_kindTable.get(kind);
						int finalBags = temp.getQuantity() + bags;
						temp.setQuantity(finalBags);
						scheduled_kindTable.put(kind, temp);
					} else {
						scheduled_kindTable.put(kind, kinds);
					}
				}
				if(print)
					System.out.println("Inside Actual Pickup:After adding in the scheduled kind table");
				output += shipment.getQuality() + "\t";
				QualityADT quality = shipment.getQuality();
				
				if( quality.equals(QualityADT.from_String("exceptional")))
					scheduled_qualityamount[0] += bags;
				
				if( quality.equals(QualityADT.from_String("very_high")))
					scheduled_qualityamount[1] += bags;
				
				if( quality.equals(QualityADT.from_String("high")))
					scheduled_qualityamount[2] += bags;
				
				if( quality.equals(QualityADT.from_String("average")))
					scheduled_qualityamount[3] += bags;
				
				if( quality.equals(QualityADT.from_String("low")))
					scheduled_qualityamount[4] += bags;
				if(print)
					System.out.println("Inside Actual Pickup:After adding quality in the scheduledlist");
				
				// here the code for setting the quality based on the quality is given!!
				output += "\n\n";
			}// end of while
		}//end of outer if
		
		
		
		if(! actualList.isEmpty())	
		{
			elements = actualList.elements();
			output += "THE ACTUAL LIST OF ORDERS\n";
			
			while( elements.hasMoreElements())
			{								
				if(print)
					System.out.println("Inside Actual Pickup:inside the actual list");
				output += "BAGS\tKIND\tQUALITY\n";
				shipment_receive = (ShipmentReceiveADT) elements.nextElement();
				output += shipment_receive.getBags() + "\t";
				int bags = shipment_receive.getBags();
				output += shipment_receive.getKind() + "\t";
				String kind = shipment_receive.getKind();
				
				kinds.setKind(kind);
				kinds.setQuantity(bags);
				
				if(receive_kindTable.isEmpty() && (receive_kindTable != null)) {	
					receive_kindTable.put(kind, kinds);
				} else	{//mens that there are some entries in the table
					if( receive_kindTable.contains(kinds) && kinds != null) {
						KindDetailsADT temp = (KindDetailsADT) receive_kindTable.get(kind);
						if( temp != null)
						{
							int finalBags = temp.getQuantity() + bags;
							temp.setQuantity(finalBags);
							receive_kindTable.put(kind, temp);
						}
					} else {
						receive_kindTable.put(kind, kinds);
					}
				}//end of else
				if(print)
					System.out.println("Inside Actual Pickup:After adding to the receive hash table");
				output += shipment_receive.getQuality() + "\t";
				QualityADT quality = shipment_receive.getQuality();
				
				if( quality.equals(QualityADT.from_String("exceptional")))
					receive_qualityamount[0] += bags;
				
				if( quality.equals(QualityADT.from_String("very_high")))
					receive_qualityamount[1] += bags;
				
				if( quality.equals(QualityADT.from_String("high")))
					receive_qualityamount[2] += bags;
				
				if( quality.equals(QualityADT.from_String("average")))
					receive_qualityamount[3] += bags;
				
				if( quality.equals(QualityADT.from_String("low")))
					receive_qualityamount[4] += bags;
				if(print)
					System.out.println("Inside Actual Pickup:After adding quality in the actual list");
				
				output += "\n\n";
			}// end of while	
		}//end of outer if
		
		
		output += "TOTAL BASED ON KINDS SCHEDULED TO BE RECEIVED\n";
		if(! scheduled_kindTable.isEmpty())
		{
			elements = scheduled_kindTable.elements();
			if(print)
				System.out.println("getting values in the scheduled table ");
			while( elements.hasMoreElements())
			{
				kinds = (KindDetailsADT) elements.nextElement();
				output += kinds.getKind() + "\t" + kinds.getQuantity() + "\n";
			}
		}//end of if
		if(print)
			System.out.println("Inside Actual Pickup:getting values form the scheduled table");
		
		output += "TOTAL BASED ON KINDS ACTUALLY RECIVED\n";
		if(! receive_kindTable.isEmpty())
		{
			elements = receive_kindTable.elements();
			while( elements.hasMoreElements())
			{
				kinds = (KindDetailsADT) elements.nextElement();
				output += kinds.getKind() + "\t" + kinds.getQuantity() + "\n";
			}
		}//end of if
		if(print)
			System.out.println("Inside Actual Pickup:After getting values form the receive table");
		
		output += "TOTAL BASED ON QUALITY : IN THE SCHEDULED LIST\n";
		output += "Exceptional\t" + scheduled_qualityamount[0] + "\n";
		output += "VeryHigh\t" + scheduled_qualityamount[1] + "\n";
		output += "High\t" + scheduled_qualityamount[2] + "\n";
		output += "Average\t" + scheduled_qualityamount[3] + "\n";
		output += "Low\t" + scheduled_qualityamount[4] + "\n";
		
		
		output += "TOTAL BASED ON QUALITY : IN THE ACTUAL RECEIVED LIST\n";
		output += "Exceptional\t" + receive_qualityamount[0] + "\n";
		output += "VeryHigh\t" + receive_qualityamount[1] + "\n";
		output += "High\t" + receive_qualityamount[2] + "\n";
		output += "Average\t" + receive_qualityamount[3] + "\n";
		output += "Low\t" + receive_qualityamount[4] + "\n";
		
		// displaying of the results
		
		/* outputArea.setText(output);
		outputArea.setEditable(false);
		JScrollPane scroller = new JScrollPane(outputArea);
		//Container c = getContentPane();
		c.add(scroller);
		// got to add this to a the main panel. there is also an internal panel to the function.
		
		//setSize(400,200);
		//show(); */
		return output;
		
	}
	
}// end of the class defenition
