/**
 * CBOS - Coffe Bean Ordering System
 * ICS52 - Software Engineering - University of California - Irvine
 * Fall 2000
 * 
 * @author Arvind Krishna
 * @author Roberto Silveira Silva Filho 
 * @version 1.0
 *
 */

package cbos.client.reports;
import javax.swing.*;
import cbos.adt.*;
import java.util.*;
import java.awt.*;
import cbos.server.*;

public class DailyPayments implements DailyPaymentsInterface
{
	private NormalPurchaseOrderInterface npi;
	private ServerFactoryInterface serverFactory;
	private boolean print = false;
	double totalpayment = 0;
	private boolean bool = true;
	private boolean bool2 = true;
	private int counter = 0;
	
	// the references of the normal orders and that of the growers is passed to invoke the functions
	public DailyPayments(NormalPurchaseOrderInterface npo, ServerFactoryInterface sf)
	{
		npi = npo;
		serverFactory = sf;
		
	}// end of the constructor call
	
	public String getOutput()
	{
		Enumeration elements;
		
		PaymentDetailsADT growerdata;
		ShipmentOrderADT shipment;
		JTextArea outputArea = new JTextArea();
		Vector list;
		Date date = new Date();
		AddressADT address;
		String output = " ";  // contains the output of the report!!

		list = npi.getPayments(date);
		
		if(print)
			System.out.println("Inside get Payments: after getting the payments");
		if(list != null)
		{
			elements = list.elements();
			while( elements.hasMoreElements())
			{
				if(print)
					System.out.println("Inside the elements loop");
				output = "GROWER NAME:";
				growerdata = (PaymentDetailsADT) elements.nextElement();
				output += growerdata.getGrowerName() +"\n";
				
				address = growerdata.getPaymentAddress();
				if(address != null)
				{
				output += "ADDRESS:\n";
				output += address.getStreet() +"\n";
				output += address.getCity() + "\n";
				
				String tempState = address.getState();
				if (tempState.equalsIgnoreCase("ca")) {
					tempState = "CO";
					Log log = serverFactory.getLog();
					log.submitBug(serverFactory.getLogin(),7);
				}
				
				output += tempState + "\n";
				output += address.getCountry() + "\t" + address.getZip() +  "\n";
				output += "(Tel):" + address.getPhoneNumber() +"\n" ;
				}
				else
				{
					output += " Address : NOT Specified \n\n";
				}
				
				Vector details = growerdata.getOrderList();
				if(details != null)
				{
					output += "BAGS\tKIND\tQUALITY\tPRICE\n";
					Enumeration listElements = details.elements();
					
					while(listElements.hasMoreElements())
					{
						shipment = (ShipmentOrderADT) listElements.nextElement();
						output += shipment.getBags() + "\t";
						output += shipment.getKind() + "\t";
						QualityADT qualityCheck = shipment.getQuality();
						if(qualityCheck.equals(QualityADT.from_String("exceptional")) && bool)
					   {
							Log log = serverFactory.getLog(); 
							String studentId = serverFactory.getLogin();
							log.submitBug(studentId, 11);
							bool = false;
						}
						output += shipment.getQuality() + "\t";
						totalpayment += shipment.getBags() * shipment.getPrice();
						counter ++;
						if(counter >= 2 && bool2)
						{
							Log log = serverFactory.getLog();
							String studentId = serverFactory.getLogin();
							log.submitBug(studentId, 12);
							bool2 = false;
						}
						output += totalpayment;
						output += "\n\n";
					}
				}
				if(print)
					System.out.println("Inside get Payments: after getting the total amount to be paid");
				output += "TOTAL AMOUNT TO BE PAID =" + totalpayment + "\n";
			}// end of the main while
		}//end of the while
		// displaying of the results
		
		/*outputArea.setText(output);
		outputArea.setEditable(false);
		JScrollPane scroller = new JScrollPane(outputArea);
		c.add(scroller);
		// here got to add the scroller on to the panel */
		
		return output;
	}
	
}// end of the class defenition
