package cbos.client.reports;

import javax.swing.*;
import cbos.adt.*;
import java.util.*;
import java.awt.*;
import cbos.server.NormalSalesOrderInterface;

public class DailyScheduleShipments implements DailyScheduleShipmentsInterface
{
	private NormalSalesOrderInterface nsi;
	private Hashtable kindTable; //stores the various kinds of coffee
	private boolean print = false;
	
	// the references of the normal orders and that of the growers is passed to invoke the functions
	public DailyScheduleShipments( NormalSalesOrderInterface nso)
	{
		nsi = nso;
		
	}// end of the constructor call
	
	public String getOutput(){
		
		Enumeration elements;
		
		ShipmentOrderADT shipment;
		JTextArea outputArea = new JTextArea();
		Vector list;
		kindTable = new Hashtable(); // stores the list per kind
		int[] qualityamount; 
		qualityamount = new int[5]; // list based on the quality
		Date date = new Date();
		AddressADT address;
		KindDetailsADT kinds = new KindDetailsADT();
		
		list = nsi.getScheduledShipments(date);
		
		String output = " ";  // contains the output of the report!!
		
		if(print)
			System.out.println("DailyScheduleShipments: Daily Scheduled after calling the function form normal purchase order");
		if(! list.isEmpty())
		{
			elements = list.elements();
			int bags;
			while( elements.hasMoreElements())
			{
				
				output += "BAGS\tKIND\tQUALITY\n";
				shipment = (ShipmentOrderADT) elements.nextElement();
				output += shipment.getBags() + "\t";
				bags = shipment.getBags();
				output += shipment.getKind() + "\t";
				String kind = shipment.getKind();
				
				kinds.setKind(kind);
				kinds.setQuantity(bags);
				
				if(kindTable.isEmpty()) {	
					kindTable.put(kind, kinds);
				} else	{//mens that there are some entries in the table
					if(kindTable.contains(kinds)) {
						KindDetailsADT temp = (KindDetailsADT) kindTable.get(kind);
						int finalBags = temp.getQuantity() + bags;
						temp.setQuantity(finalBags);
						kindTable.put(kind, temp);
					} else {
						kindTable.put(kind, kinds);
					}
				}//end of else
				
				if(print)
					System.out.println("Daily Scheduled:after ading in the hash table");
				output += shipment.getQuality() + "\t";
				QualityADT quality = shipment.getQuality();
				
				if( quality.equals(QualityADT.from_String("exceptional")))
					qualityamount[0] += bags;
				
				if( quality.equals(QualityADT.from_String("very_high")))
					qualityamount[1] += bags;
				
				if( quality.equals(QualityADT.from_String("high")))
					qualityamount[2] += bags;
				
				if( quality.equals(QualityADT.from_String("average")))
					qualityamount[3] += bags;
				
				if( quality.equals(QualityADT.from_String("low")))
					qualityamount[4] += bags;
				
				if(print)
					System.out.println("Daily Scheduled:After adding in the quality list");
				// here the code for setting the quality based on the quality is given!!
				output += "\n\n";
			}// end of while
		}//	end of the outer if
		
		output += "TOTAL BASED ON KINDS\n";
		if(!( kindTable.isEmpty()))
		{
			elements = kindTable.elements();
			while( elements.hasMoreElements()){
				if(print)
					System.out.println("Daily Scheduled:retrieving the kinds list");
				kinds = (KindDetailsADT) elements.nextElement();
				output += kinds.getKind() + "\t" + kinds.getQuantity() + "\n";
			}
		}// end of if 
		
		output += "TOTAL BASED ON QUALITY\n";
		output += "Exceptional\t" + qualityamount[0] + "\n";
		output += "VeryHigh\t" + qualityamount[1] + "\n";
		output += "High\t" + qualityamount[2] + "\n";
		output += "Average\t" + qualityamount[3] + "\n";
		output += "Low\t" + qualityamount[4] + "\n";
		
		// displaying of the results
		
		outputArea.setText(output);
		outputArea.setEditable(false);
		JScrollPane scroller = new JScrollPane(outputArea); 
		
		// got to add the scroll pane on to the main screen 
		if(print)
			System.out.println("Daily Pick up:Leaving the function");			
		
		return output;
	}
	
}// end of the class defenition

