package cbos.client.reports;
import javax.swing.*;
import cbos.server.*;
import java.util.*;
import cbos.adt.*;
import java.awt.*;

/**
 * this report generates the monthly purchases made by each grower
 * @param requires the list of growers
 * @param the NormalPurchaseOrder reference and the GrowerModule interface are passed for accessing functions to get the details
 * @return a frame containing the list of al the purchases by all the growers
 * @version 1.0
 */

public class PurchasePerGrower implements PurchasePerGrowerInterface
{
	private NormalPurchaseOrderInterface npi;
	private GrowerInterface gi;
	private ClientADT growerdata;
	private ShipmentReceiveADT shipment;
	private JTextArea outputArea = new JTextArea();
	private Vector list;
	private int counter =0;
	private String growerName;	
	
	// the references of the normal orders and that of the growers is passed to invoke the functions
	public PurchasePerGrower(NormalPurchaseOrderInterface npo, GrowerInterface gui)
	{
			
		npi = npo;
		gi = gui;
						
	}// end of the constructor call
	
	public String getOutput(String growerName)
	{
		 Enumeration elements;
		
		ClientADT growerdata;
		ShipmentReceiveADT shipment;
		JTextArea outputArea = new JTextArea();
		Vector list;
		int counter =0;
		
		String output = " ";  // contains the output of the report!!
		//------------------------------------------------------------
		output = "GROWER NAME:";
		output += growerName + "\n";
		list = npi.getGrowerPurchases(growerName);
		output += "BAGS\tKIND\tQUALITY\t\tDATE\n";
		if( list != null)
		{
		
			Enumeration listElements = list.elements();
			while(listElements.hasMoreElements())
			{
				shipment = (ShipmentReceiveADT) listElements.nextElement();
				output += shipment.getBags() + "\t";
				output += shipment.getKind() + "\t";
				output += shipment.getQuality() + "\t";
				output += shipment.getDate()+ "\t";
				output += "\n\n";
			}
		}
			return output;
			
	}// end of getOutput
	
		
}
