/**
 * CBOS - Coffe Bean Ordering System
 * ICS52 - Software Engineering - University of California - Irvine
 * Fall 2000
 * 
 * @author Arvind Krishna
 * @author Roberto Silveira Silva Filho 
 * @version 1.0
 *
 */

package cbos.server;
import cbos.adt.*;

import java.util.*;

/**
 * Implements the customer database
 */
public class Customer implements CustomerInterface, java.io.Serializable {
	
	private Hashtable customerTable = null;
	private ClientADT customer = null;
	
	private boolean print = false;
	
	/**
	 * Constructor
	 */
	public Customer()
	{
		if (customerTable == null) 
			customerTable = new Hashtable(10, (float) 0.75);
	}
	
	public void addCustomerDetails(String customerName, AddressADT address) {
	
		if (print) {
			System.out.println("Customer: adding CustomerDetails...");
			System.out.println("Customer: customerName: "+customerName);
			System.out.println("Customer: address: "+address);
		}
		
		ClientADT customer = new ClientADT();
		customer.setClientName(customerName);
		customer.setAddress(address);
		
		customerTable.put( customerName, customer);
	}
	
	public void deleteCustomerDetails(String customerName) {
	
	}
	
	public AddressADT getBillingAddress(String customerName) {
	
		ClientADT customer;
		
		if (print) {
			System.out.println("Customer: gettiny Billing Addess...");
			System.out.println("customer: customerName: "+customerName);
		}
			
		AddressADT address = new AddressADT();
		customer = (ClientADT) customerTable.get(customerName);
		if( customer == null)  // the guy is a new customer
		  return null;
		else
			return customer.getAddress();
	
	}
	
	public void updateBillingAddress(String customerName, AddressADT address) {
	
		if (print) {
			System.out.println("customer: updating billing address...");
			System.out.println("customer: customerName: "+customerName);
			System.out.println("customer: address: "+address);
		}
		
		
       ClientADT order = new ClientADT();
	   order.setClientName(customerName);
	   order.setAddress(address);
	   customerTable.remove(customerName); // removes the prevoius entry in the table
	   customerTable.put(customerName, order);

	}
	
	/**
	 * Returns the list of all customers in the system.
	 * @return a vector with ClientADT elements
	 */
	public Vector getCustomersList() {
		
		if (print)
			System.out.println("Customer: getting customer list...");
		
		Vector list = new Vector(0,1);
		Enumeration elements;
		elements = customerTable.elements();
		
		while( elements.hasMoreElements())
			list.addElement((ClientADT) elements.nextElement());
		
		if (print)
			System.out.println("Customer: returning: "+list);
		
		return list;
	}
	
	public void clearAll() {
		customerTable.clear();
	}
}
