package cbos.server;
import cbos.adt.*;
import java.util.*;

public class Grower implements GrowerInterface, java.io.Serializable
{
	private Hashtable growerTable = null;
	static int timesLoopCounter = 0; // debugger use counter
	
	private boolean print = false;
	
	/**
	 * Constructor
	 */
	public Grower()
	{
		if (growerTable == null)
			growerTable = new Hashtable(10, (float) 0.75);
		
	}
	
	public void addGrowerDetails(ClientADT grower)
	{
		Object obj = null;
		
		if (print) {
			System.out.println("----------------------------------------");
			System.out.println("Grower: adding GrowerDetails...");
			System.out.println("name = "+grower.getClientName());
			
		}
		//if(growerTable.contains(grower))
		//System.out.println("there are two keys mapping to the same location");
		obj = growerTable.put(grower.getClientName(), grower);
		//growerTable.addElement(grower);
		if(print)
		{
			System.out.println("grower name added");
			System.out.println("Growerfunction called" + timesLoopCounter++);
			System.out.println("--------------------------------------");
		}
		/*if(obj != null)
		System.out.println("AddGrowerDetails  :owerwrting"); */
		
	}
	
	public void removeGrower(String growerName) {
		if (print) {
			
				System.out.println("Grower: removing GrowerDetails...");
				System.out.println("Grower: ClientADT: "+growerName);
			}
		
		if(growerTable.remove((String) growerName) == null)
			
		{
			if (print) 
				System.out.println("Deletion grower unsuccessful....");
		}
		
		//----- code for vector---------------------------
		/*
		ClientADT client = null;
		if(growerTable != null)
		{
		for( int i=0; i < growerTable.size(); i++)
		{
		client = (ClientADT) growerTable.elementAt(i);
		if(client.getClientName().equals(growerName))
		{
		growerTable.remove(i);
		break;
		}
		}//end of the for
		}//end of the if
		
		*/
	}//end of the operation
	
	/**
	 * Returns the payment address AddressADT of the grower
	 */
	public AddressADT getPaymentAddress(String growerName) 
	{
		ClientADT grower = null;
		
		if (print) {
			System.out.println("Grower: getting payment Address...");
			System.out.println("Grower: growerName: "+growerName);
		}
		if(!( growerTable.isEmpty()))
		{
			grower = (ClientADT) growerTable.get(growerName);
		}
		
		if (grower == null)  // the guy is a new grower
			return null;
		else
			return grower.getAddress(); 
		
		//-------- code for vector implementation--------------
		/*
		AddressADT address = null;
		if(! growerTable.isEmpty())
		{
		for(int i=0; i < growerTable.size(); i++)
		{
		grower = (ClientADT)growerTable.elementAt(i);
		if(grower.getClientName().equals(growerName)) {
		address = grower.getAddress();
		break;
		}
		}//end of the for
		}//end of if
		*/
		
		
	}//end of the function
	
	/**
	 * Updates the payment address of a grower
	 * @param growerName name of the grower to update the AddressADT
	 * @param address AddressADT having the new information
	 */
	public void updatePaymentAddress(String growerName, AddressADT address)
	{
		
		if (print) {
			System.out.println("Grower: updating payment address...");
			System.out.println("Grower: growerName: "+growerName);
			System.out.println("Grower: address: "+address);
		}
		
		
		ClientADT order = new ClientADT();
		order.setClientName(growerName);
		order.setAddress(address);
		growerTable.remove(growerName); // removes the prevoius entry in the table
		growerTable.put(growerName, order); 
		
		// -------------------code for vector-------------------------
		
		/*
		ClientADT grower = null;
		if(! growerTable.isEmpty())
		{
		for (int i=0; i < growerTable.size(); i++)
		{
		grower = (ClientADT) growerTable.elementAt(i);
		if(grower.getClientName().equals(growerName))
		{
		grower.setAddress(address);
		break;
		}
		}//end of for
		}//end of if
		*/	

	}//end of function
	
	public void clearTable()
	{
		growerTable.clear();
		//growerTable.removeAllElements();
		timesLoopCounter++;
	}
	
	/**
	 * Returns the list of all growers in the system.
	 * @return a vector with ClientADT elements
	 */
	public Vector getGrowersList() {
		ClientADT client = null;
		
		if (print)
			System.out.println("Grower: getting grower list...");
		
		Vector list = new Vector(0,1);
		Enumeration elements;
		if(print)
		{
			System.out.println("Inside grower list");
			System.out.println("----------------------------------------");
		}
		if(! growerTable.isEmpty())
		{
			
			for (elements = growerTable.elements() ; elements.hasMoreElements() ;) 
				
			{
				client = (ClientADT) elements.nextElement();
				if(print)
					System.out.println("growerName = "+ client.getClientName());
				list.addElement(client);
			}
			if(print)
				System.out.println("-----------------------------");
			
		}
		return list;
		
	}// end of the function
	
	public void print()
	{
		ClientADT client = null;
		if( ! growerTable.isEmpty())
		{
			if(print)
			{
				System.out.println("--------------------------------------------------");
				System.out.println("Grower: The size of the vector"+ growerTable.size());
			}
			
			Vector growerList = getGrowersList();
			for (int i=0; i < growerList.size(); i++)
			{
				//client = (ClientADT) growerTable.elementAt(i);
				if(print)
					System.out.println("Grower: growerName = "+ ((ClientADT) growerList.elementAt(i)).getClientName());				
			}
		}
		else
		{
			if(print)
				System.out.println("No elements are present");
		}
		if(print)
			System.out.println("--------------------------------------------------");
	}
	
}// end of the class defenition
