/**
 * CBOS - Coffe Bean Ordering System
 * ICS52 - Software Engineering - University of California - Irvine
 * Fall 2000
 * 
 * @author Arvind Krishna
 * @author Roberto Silveira Silva Filho 
 * @version 1.0
 *
 */

package cbos.server;

import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;

public class Kind implements cbos.server.KindInterface, java.io.Serializable {

	private Hashtable kindsTable = null; // Vector of strings

	private boolean print = false;
	/**
	 * Constructor
	 */
	public Kind() {
		
		if (print)
			System.out.println("Kind: constructor called...");
		
		if (kindsTable == null)
			kindsTable = new Hashtable(10, (float) 0.75);
	}

	/**
	 * Add a kind to the list
	 */
	public void addKind(String name) {
		String current;
		boolean exists = false;
		
		if (print) {
			System.out.println("Kind: adding a new kind...");
			System.out.println("Kind: kind: "+name);
		}
		
		kindsTable.put(name, name);
	}

	/**
	 * Removes a kind from the list
	 */
	public void removeKind(String name) {
	
		String current;
		
		if (print) {
			System.out.println("Kind: removing a kind...");
			System.out.println("Kind: kind: "+name);
		}
		
		kindsTable.remove(name);
	}

	/**
	 * @return a vector of string with all kinds
	 */
	public Vector getAllKinds() {
		
		Vector kindsList = new Vector(0,1);
		
		if (print) {
			System.out.println("Kind: returning all kinds...");
			System.out.println("Kind: kindsTable: "+kindsTable);
		}
		
		Enumeration enum = kindsTable.elements();
		
		while(enum.hasMoreElements()) {
			kindsList.addElement(enum.nextElement()); 
		}
	
		return kindsList;
	}
	
	/**
	 * Clears all kinds
	 */
	public void clearAll() {
		kindsTable.clear();
	}
} 
