/**
 * CBOS - Coffe Bean Ordering System
 * ICS52 - Software Engineering - University of California - Irvine
 * Fall 2000
 * 
 * @author Arvind Krishna
 * @author Roberto Silveira Silva Filho 
 * @version 1.0
 *
 */

package cbos.server;
import cbos.adt.*;

import java.util.Vector;
import java.util.Date;
import java.util.Enumeration;

public interface NormalPurchaseOrderInterface
{
	//public static int getCurrentPurchaseOrderCounter();
	
	public int getCurrentPurchaseOrderCounter();
	public String addNormalPurchaseOrder(PurchaseOrderADT purchase);
	public boolean updatePurchaseOrder(ShipmentReceiveADT shipment, String PONumber);
	public double getPriceDetails(String PONumber, String kind, QualityADT quality); //returns the price of the coffee
	public Vector getScheduledPickUp(Date date);
	public Vector getActualPickUp(Date date);
	public Vector getGrowerPurchases(String growerName);
	public void scheduleRepeatPurchaseOrder(PurchaseOrderADT order); // RPnumber is the repeat purchase order number
	public Vector getPayments(Date date); // returns the payments that are due to the grower in the form of a list:Vector
	public Enumeration getOrderNumbers();
	public void reconfigure(GrowerInterface gi);
	
}
