/**
 * CBOS - Coffe Bean Ordering System
 * ICS52 - Software Engineering - University of California - Irvine
 * Fall 2000
 * 
 * @author Arvind Krishna
 * @author Roberto Silveira Silva Filho 
 * @version 1.0
 *
 */
package cbos.server;

import cbos.adt.*;

public class PurchaseParser implements ParserInterface
{
   	
	private NormalPurchaseOrderInterface normalOrder;
	private RepeatPurchaseOrderInterface repeatOrder;
	
	public PurchaseParser(NormalPurchaseOrderInterface npi, RepeatPurchaseOrderInterface rpi)
	{
		normalOrder = npi;
		repeatOrder = rpi;
	}
	
	public String addPurchaseOrder(OrderADT order)
	{
		String s = null;
		if( order instanceof PurchaseOrderADT)
		{
			 s = normalOrder.addNormalPurchaseOrder( (PurchaseOrderADT) order);
			 return s;
		}
			
		else
		{
			s = repeatOrder.addRepeatPurchaseOrder( (RepeatPurchaseOrderADT) order);
			return s;
		}
		
	}
								   
} // end of the Purchase Parser class
