/**
 * CBOS - Coffe Bean Ordering System
 * ICS52 - Software Engineering - University of California - Irvine
 * Fall 2000
 * 
 * @author Arvind Krishna
 * @author Roberto Silveira Silva Filho 
 * @version 1.0
 *
 */

package cbos.server;
import cbos.adt.*;

import java.util.*;
import cbos.exceptions.*;

public class RepeatPurchaseOrder implements RepeatPurchaseOrderInterface, java.io.Serializable
{
	private Hashtable repeatPurchaseOrderTable = null;
	private PurchaseOrderADT order = null;
	private int RPNumber; // Repeat purchase counter
		
	private boolean print = false;
	
	public RepeatPurchaseOrder()
	{
		if (repeatPurchaseOrderTable == null) {
			repeatPurchaseOrderTable = new  Hashtable(10, (float) 0.75);
			 RPNumber = 1;
		}
	}

	public String addRepeatPurchaseOrder(RepeatPurchaseOrderADT order)
	{
		RPNumber ++;
		String rp_purchaseOrderNumber = "RP"+RPNumber;
		order.setOrderNumber(rp_purchaseOrderNumber);
		if(print)
			System.out.println("inside Repeat PurchaseOrdrr: adding");
		repeatPurchaseOrderTable.put(order, rp_purchaseOrderNumber);
		return rp_purchaseOrderNumber;
	}
	
	/**
	 * @param the function appends the repeatPo number to the order in the form of RP<number>-<shipment>
	 * @param this is used to convert the repeat PO to a normal PurchaseOrder.
	 */
	
	public Vector checkDueRepeatOrder(Date date) throws Exception
	{
		
		RepeatPurchaseOrderADT order;
		Date start, end;
		int interval, counter;
		Vector list = new Vector();
		String RPnumber; // repeat purchase order number
		if( ! repeatPurchaseOrderTable.isEmpty())
		{
			Enumeration elements = repeatPurchaseOrderTable.elements();
			while( elements.hasMoreElements())
			{
				order = (RepeatPurchaseOrderADT) elements.nextElement();
				start = order.getBeginDate();
				end = order.getEndDate();
				interval = order.getInterval();
				
				RPnumber = order.getOrderNumber();
				if((date.compareTo(end)) < 0) // it maens that the end date is not yet over
				{
					int m1 = getMonth(start);
					int m2 = getMonth(date);
					int y1 = getYear(start);
					int y2 = getYear(date);
					int d1 = getDay(start);
					int d2 = getDay(date);
					if( (m1 > 12) | ( m2 > 12) | ( m1 < 0) | ( m2 < 0) | (d1 > 31) | (d2 > 31) | ( y1 < 0) | ( y2 < 0))
						throw ( new  Exception( " There is a negative data in the date field")); 
					else
					{
						int days = mainfunction(m1,m2,d1,d2,y1,y2);
						if( (days % interval) <= 10) // ten days before the due date the system has to add the order
						{
							counter = days/interval; // this is for appending the shipment 1,2,3 at the end with the RP order
							RPnumber += "-"+ counter;
							order.setOrderNumber(RPnumber); // this appends RP1243-1 to indicate the shipment
							list.addElement(order);
						}
					}
				}
				else
					repeatPurchaseOrderTable.remove(order.getOrderNumber());
				// if the end date is over then the entry is deleted form the table. 
			}
		} // end of the if condition 
		
		
		return list;	
		
	}// end of the main function
	
	public int getDay(Date date)
	{
		StringTokenizer tokens = new StringTokenizer(date.toString());
		String temp = tokens.nextToken();
		return Integer.valueOf(temp).intValue();
	}
	
	public int getMonth(Date date)
	{
		String months[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
		int i, value =0;
		String temp;
		
		StringTokenizer tokens = new StringTokenizer(date.toString());
		temp = tokens.nextToken();
		temp = tokens.nextToken(); // has the month in the date
		for(i=0; i<12; i++)
			if(months[i].equals(temp))
				value = i+1;
		return(value);
	}
	
	public int getYear(Date date)
	{
		String temp = null;
		StringTokenizer tokens = new StringTokenizer(date.toString());
		while( tokens.hasMoreTokens())
		{
			temp = tokens.nextToken();
		}
		return Integer.valueOf(temp).intValue();
	}
	
	public boolean is_leap(int y) {
		if( (y %4 == 0) || (y % 400 == 0))
			return true;
		else 
			return false;
	}

	public int days_in_year(int  y) {
		
		if(print)
			System.out.println("entered the year loop\n");
		
		if( (y %4 == 0) || (y % 400 == 0))
			return 366;
		else 
			return 365;
	}
	
	public int days_in_month(int m, int y) 
	{
		int daysarr [] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
		if (( m == 2) && is_leap(y))
			return 29;
		else
			if( m == 2)
				return 28;
			else 
				return daysarr[m-1];
	}

	public int mainfunction(int m1, int m2, int d1, int d2, int y1, int y2)
	{
		int days=0,i, j;
		
		if( (y1 == y2) && ( m1 == m2))
			return (d2 -d1);
		else
		{
			if( (y1 == y2) && ( m1 != m2))
			{
				days += days_in_month(m1,y1) - d1;
				m1++;
				days += d2;
				m2--;
				for( i = m1; i <= m2; i++)
					days += days_in_month(i, y1);
				return days;
			}
			else
			{
				days += days_in_month(m1,y1) - d1;
				m1++;
				days += d2;
				m2--;
				for(i=m1; m1 >= 1 && m1 <=12; m1++)
				{
					days += days_in_month(m1, y1);
				}
				y1++;
				for(i=1; m2 >= 1 && i <= m2; i++)
				{
					days += days_in_month(m2, y2);
				}
				y2--;
				while( y1 <= y2)
				{
					days += days_in_year(y1);
					y1++;
				}
				return days;
			}
		}
		
	}// end of mainfunction
	
} // end of the class defintion

