/**
 * CBOS - Coffe Bean Ordering System
 * ICS52 - Software Engineering - University of California - Irvine
 * Fall 2000
 * 
 * @author Arvind Krishna
 * @author Roberto Silveira Silva Filho 
 * @version 1.0
 *
 */

package cbos.server;

public interface ServerFactoryInterface {
	
	public void createServerSide ();
	public void createServerSide(String uid, int numberBugs);
	public void saveGrower (String dirname, String filename);
	public void saveKind (String dirname, String filename);
	public void saveCustomer (String dirname, String filename);
	public void saveInventory (String dirname, String filename);
	public void saveRSScheduler (String dirname, String filename);
	public void saveRPScheduler (String dirname, String filename);
	public void saveRepeatPurchaseOrder (String dirname, String filename);
	public void saveNormalPurchaseOrder (String dirname, String filename);
	public void saveRepeatSalesOrder (String dirname, String filename);
	public void saveNormalSalesOrder (String dirname, String filename);
	public void saveUser(String dirname, String filename);
	public void saveAll();
	
	public GrowerInterface createGrower(String filename, String dirname);
	public KindInterface createKind(String filename, String dirname);
	public InventoryInterface createInventory(String filename, String dirname);
	public RPSchedulerInterface createRPScheduler(String filename, String dirname, RepeatPurchaseOrderInterface repeatPO, NormalPurchaseOrderInterface normalPO);
	public RSSchedulerInterface createRSScheduler(String filename, String dirname, RepeatSalesOrderInterface repeatSO, NormalSalesOrderInterface normalSO);
	public CustomerInterface createCustomer(String filename, String dirname);
	public RepeatPurchaseOrderInterface createRepeatPurchaseOrder(String filename, String dirname);
	public NormalPurchaseOrderInterface createNormalPurchaseOrder(String filename, String dirname, GrowerInterface gi);	
	public RepeatSalesOrderInterface createRepeatSalesOrder(String filename, String dirname);
	public NormalSalesOrderInterface createNormalSalesOrder(String filename, String dirname, CustomerInterface ci);
	public UserInterface createUser(String filename, String dirname);
	
	public GrowerInterface getGrower();
	public KindInterface getKind();
	public UserInterface getUser();
	public CustomerInterface getCustomer();
	public InventoryInterface getInventory();
	public RPSchedulerInterface getRPScheduler();
	public RSSchedulerInterface getRSScheduler();
	public NormalPurchaseOrderInterface getNormalPurchaseOrder();
	public RepeatPurchaseOrderInterface getRepeatPurchaseOrder();
	public NormalSalesOrderInterface getNormalSalesOrder();
	public RepeatSalesOrderInterface getRepeatSalesOrder();
	public Log getLog();
	
	public String getLogin();
	public void setLogin(String value);
}
